From a21c7f496cf567afdd6d8b0ec70e1aa27c1b449e Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 719/1001] Convert the fhosted widget


---

diff --git a/hubs/widgets/fhosted/__init__.py b/hubs/widgets/fhosted/__init__.py
new file mode 100644
index 0000000..ec1dc93
--- /dev/null
+++ b/hubs/widgets/fhosted/__init__.py
@@ -0,0 +1,90 @@
+from __future__ import unicode_literals
+
+from six.moves.xmlrpc_client import ServerProxy
+
+from hubs import validators
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
+
+
+class FedoraHosted(Widget):
+
+    name = "fhosted"
+    position = "right"
+    arguments = [
+        dict(
+            name="project",
+            label="Project",
+            default=None,
+            validator=validators.fedorahosted_project,
+            help="Name of the trac instance on fedorahosted.org.",
+        ), dict(
+            name="n_tickets",
+            label="Number of tickets",
+            default=4,
+            validator=validators.integer,
+            help="The number of tickets to display.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/fedorahosted.html"
+    chrome = panel("Fedorahosted: Open Tickets")
+
+    def get_context(self, instance, *args, **kwargs):
+        get_tickets = GetTickets(instance)
+        context = dict(project=instance.config["project"])
+        context.update(get_tickets())
+        return context
+
+
+class GetTickets(CachedFunction):
+    ''' Data for Fedorahosted widget.
+    Queries Fedorahosted via xmlrpc for tickets. '''
+
+    def execute(self):
+        n_tickets = int(self.instance.config["n_tickets"])
+        url = 'https://fedorahosted.org/%s/rpc' \
+            % self.instance.config["project"]
+        filters = 'status=accepted&status=assigned&status=new&status=reopened'\
+            '&col=id&col=summary&col=status&col=owner&col=type&col=priority'\
+            '&col=milestone&col=changetime&order=changetime'
+
+        # get the tickets based on the filters
+        # returns a list of ticket ids
+        try:
+            server = ServerProxy(url)
+            tickets = server.ticket.query(filters)
+        except:
+            return dict(
+                error='Invalid or wrongly configured project'
+            )
+
+        output = []
+        total_tickets = len(tickets)
+        for ticket in tickets[:n_tickets]:
+            # get the details of the ticket
+            ticket = server.ticket.get(ticket)
+            data = ticket[3]
+            data['id'] = ticket[0]
+            data['short_summary'] = data['summary'][:45]
+            output.append(data)
+
+        return dict(
+            tickets=output,
+            total_tickets=total_tickets,
+        )
+
+    def should_invalidate(self, message):
+        ''' Checks if the Fedorahosted widget needs an update.
+        Called by backend daemon listening to fedmsg '''
+        if '.trac.ticket' in message['topic']:
+            project = self.instance.config.get("project", "")
+            url = 'https://fedorahosted.org/%s/' % project
+            if message['msg']['instance']['base_url'] == url:
+                return True
+        return False

